%global scl devtoolset-2
%{?scl:%scl_package}
Summary: Package that installs %scl
Name: %scl_name
Version: 2.1
Release: 4%{?dist}
BuildArch: noarch
License: GPLv2+
Group: Applications/File
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: %{scl_prefix}toolchain %{scl_prefix}ide %{scl_prefix}perftools %{scl_prefix}vc
%{?scl:BuildRequires: scl-utils-build}
%{?scl:BuildRequires: iso-codes}

%description
This is the main package for %scl Software Collection.

%package runtime
Summary: Package that handles %scl Software Collection.
Group: Applications/File
Requires: scl-utils
Requires(post): libselinux policycoreutils-python
Requires(postun): libselinux policycoreutils-python
Requires(preun): libselinux policycoreutils-python

%description runtime
Package shipping essential scripts to work with %scl Software Collection.

%package build
Summary: Package shipping basic build configuration
Group: Applications/File

%description build
Package shipping essential configuration macros to build %scl Software Collection.

%package toolchain
Summary: Package shipping basic toolchain applications
Group: Applications/File
Requires: %{scl_prefix}runtime
Requires: %{scl_prefix}gcc %{scl_prefix}gcc-c++ %{scl_prefix}gcc-gfortran
Requires: %{scl_prefix}binutils %{scl_prefix}gdb %{scl_prefix}strace
Requires: %{scl_prefix}dwz %{scl_prefix}elfutils %{scl_prefix}memstomp
%{?scl:BuildRequires: scl-utils-build}
%{?scl:BuildRequires: iso-codes}

%description toolchain
Package shipping basic toolchain applications (compiler, debugger, ...)

%package ide
Summary: Package shipping Eclipse IDE
Group: Applications/File
Requires: %{scl_prefix}runtime
Requires: %{scl_prefix}eclipse-cdt
Requires: %{scl_prefix}eclipse-cdt-parsers
Requires: %{scl_prefix}eclipse-cdt-sdk
Requires: %{scl_prefix}eclipse-changelog
Requires: %{scl_prefix}eclipse-egit
Requires: %{scl_prefix}eclipse-emf
Requires: %{scl_prefix}eclipse-emf-core
Requires: %{scl_prefix}eclipse-emf-examples
Requires: %{scl_prefix}eclipse-emf-sdk
Requires: %{scl_prefix}eclipse-emf-xsd
Requires: %{scl_prefix}eclipse-emf-xsd-sdk
Requires: %{scl_prefix}eclipse-equinox-osgi
Requires: %{scl_prefix}eclipse-gcov
Requires: %{scl_prefix}eclipse-gef
Requires: %{scl_prefix}eclipse-gef-examples
Requires: %{scl_prefix}eclipse-gef-sdk
Requires: %{scl_prefix}eclipse-gprof
Requires: %{scl_prefix}eclipse-jdt
Requires: %{scl_prefix}eclipse-jgit
Requires: %{scl_prefix}eclipse-linuxtools
Requires: %{scl_prefix}eclipse-manpage
Requires: %{scl_prefix}eclipse-oprofile
Requires: %{scl_prefix}eclipse-pde
Requires: %{scl_prefix}eclipse-perf
Requires: %{scl_prefix}eclipse-platform
Requires: %{scl_prefix}eclipse-rcp
Requires: %{scl_prefix}eclipse-rpm-editor
Requires: %{scl_prefix}eclipse-rpmstubby
Requires: %{scl_prefix}eclipse-rse
Requires: %{scl_prefix}eclipse-rse-server
Requires: %{scl_prefix}eclipse-swt
Requires: %{scl_prefix}eclipse-systemtap
Requires: %{scl_prefix}eclipse-valgrind
Requires: %{scl_prefix}eclipse-mylyn
Requires: %{scl_prefix}eclipse-mylyn-builds
Requires: %{scl_prefix}eclipse-mylyn-builds-hudson
Requires: %{scl_prefix}eclipse-mylyn-context-cdt
Requires: %{scl_prefix}eclipse-mylyn-context-java
Requires: %{scl_prefix}eclipse-mylyn-context-pde
Requires: %{scl_prefix}eclipse-mylyn-context-team
Requires: %{scl_prefix}eclipse-mylyn-docs-epub
Requires: %{scl_prefix}eclipse-mylyn-docs-htmltext
Requires: %{scl_prefix}eclipse-mylyn-docs-wikitext
Requires: %{scl_prefix}eclipse-mylyn-ide
Requires: %{scl_prefix}eclipse-mylyn-sdk
Requires: %{scl_prefix}eclipse-mylyn-tasks-bugzilla
Requires: %{scl_prefix}eclipse-mylyn-tasks-trac
Requires: %{scl_prefix}eclipse-mylyn-tasks-web
Requires: %{scl_prefix}eclipse-mylyn-versions
Requires: %{scl_prefix}eclipse-mylyn-versions-cvs
Requires: %{scl_prefix}eclipse-mylyn-versions-git
%{?scl:BuildRequires: scl-utils-build}
%{?scl:BuildRequires: iso-codes}

%description ide
Package shipping Eclipse IDE

%package perftools
Summary: Package shipping performance tools
Group: Applications/File
Requires: %{scl_prefix}runtime
Requires: %{scl_prefix}oprofile %{scl_prefix}systemtap %{scl_prefix}valgrind
Requires: %{scl_prefix}dyninst
%{?scl:BuildRequires: scl-utils-build}
%{?scl:BuildRequires: iso-codes}

%description perftools
Package shipping performance tools (systemtap, oprofile)

%package vc
Summary: Package shipping version control system
Group: Applications/File
Requires: %{scl_prefix}git
%{?scl:BuildRequires: scl-utils-build}
%{?scl:BuildRequires: iso-codes}

%description vc
Package shipping version control system (git)

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/%{_scl_scripts}/root
cat > %{buildroot}/%{_scl_scripts}/enable <<\EOF
export PATH=%{_bindir}${PATH:+:${PATH}}
export MANPATH=%{_mandir}:$MANPATH
export INFOPATH=%{_infodir}${INFOPATH:+:${INFOPATH}}
export PCP_DIR=%{_scl_root}
# Some perl Ext::MakeMaker versions install things under /usr/lib/perl5
# even though the system otherwise would go to /usr/lib64/perl5.
export PERL5LIB=%{_scl_root}/%{perl_vendorarch}:%{_scl_root}/usr/lib/perl5:%{_scl_root}/%{perl_vendorlib}${PERL5LIB:+:${PERL5LIB}}
# bz847911 workaround:
# we need to evaluate rpm's installed run-time % { _libdir }, not rpmbuild time
# or else /etc/ld.so.conf.d files?
rpmlibdir=`rpm --eval "%%{_libdir}"`
# bz1017604: On 64-bit hosts, we should include also the 32-bit library path.
if [ "$rpmlibdir" != "${rpmlibdir/lib64/}" ]; then
  rpmlibdir32=":%{_scl_root}${rpmlibdir/lib64/lib}"
fi
export LD_LIBRARY_PATH=%{_scl_root}$rpmlibdir$rpmlibdir32${LD_LIBRARY_PATH:+:${LD_LIBRARY_PATH}}
# duplicate python site.py logic for sitepackages
pythonvers=`python -c 'import sys; print sys.version[:3]'`
export PYTHONPATH=%{_prefix}/lib64/python$pythonvers/site-packages:%{_prefix}/lib/python$pythonvers/site-packages${PYTHONPATH:+:${PYTHONPATH}}
EOF
mkdir -p %{buildroot}/%{_scl_root}/usr/bin
cat > %{buildroot}/%{_scl_root}/usr/bin/sudo <<\EOF
#! /bin/sh
# TODO: parse & pass-through sudo options from $@
sudo_options="-E"

for arg in "$@"
do
   case "$arg" in
    *\'*)
      arg=`echo "$arg" | sed "s/'/'\\\\\\\\''/g"` ;;
   esac
   cmd_options="$cmd_options '$arg'" 
done

exec /usr/bin/sudo $sudo_options LD_LIBRARY_PATH=$LD_LIBRARY_PATH PATH=$PATH scl enable devtoolset-2 "$cmd_options"
EOF
chmod 0755 %{buildroot}/%{_scl_root}/usr/bin/sudo
%scl_install
cat >> %{buildroot}%{_root_sysconfdir}/rpm/macros.%{scl}-config <<\EOF
%%scl_maven_opts export MAVEN_OPTS="-Dmaven.local.jar.paths=%{_scl_root}/ \
							-Dmaven.local.pom.paths=%{_scl_root}/usr/share/maven-poms/ \
							-Dmaven.local.depmap.dir=%{_scl_root}/usr/share/maven-fragments/"
EOF
find %{buildroot}%{_scl_root} -type d | xargs chmod 755
mkdir -p %{buildroot}%{_sysconfdir}/alternatives
mkdir -p %{buildroot}%{_scl_root}/var/lib/alternatives
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_prefix}/lib
mkdir -p %{buildroot}%{_prefix}/lib64
mkdir -p %{buildroot}%{_libexecdir}
mkdir -p %{buildroot}%{_mandir}
mkdir -p %{buildroot}%{_infodir}
mkdir -p %{buildroot}%{_includedir}
mkdir -p %{buildroot}%{_datadir}/locale
mkdir -p %{buildroot}%{_docdir}

#maven support
ln -s %{_scl_root}/usr/share/java/ JPP

%files

%files runtime
%defattr(-,root,root,-)
%scl_files
%{_scl_root}/usr/bin/sudo
%attr(0644,root,root) %verify(not md5 size mtime) %ghost %config(missingok,noreplace) %{_sysconfdir}/selinux-equiv.created

%files build
%{_root_sysconfdir}/rpm/macros.%{scl}-config
%{_scl_root}/JPP

%files toolchain

%files ide

%files perftools

%files vc

%post runtime
if [ ! -f %{_sysconfdir}/selinux-equiv.created ]; then
  /usr/sbin/semanage fcontext -a -e / %{_scl_root}
  restorecon -R %{_scl_root}
  touch %{_sysconfdir}/selinux-equiv.created
fi

%preun runtime
[ $1 = 0 ] && rm -f %{_sysconfdir}/selinux-equiv.created || :

%postun runtime
if [ $1 = 0 ]; then
  /usr/sbin/semanage fcontext -d %{_scl_root}
  [ -d %{_scl_root} ] && restorecon -R %{_scl_root} || :
fi

%changelog
* Fri Nov 01 2013 Marek Polacek <polacek@redhat.com> 2.1-4
- bz1025424: add new subpackage -vc.  Require git.

* Mon Oct 14 2013 Marek Polacek <polacek@redhat.com> 2.1-3
- bz1017604: add 32-bit library path to LD_LIBRARY_PATH

* Mon Oct 07 2013 Marek Polacek <polacek@redhat.com> 2.1-2
- bz1001046: propagate PATH variable to sudo.

* Thu Oct 03 2013 Marek Polacek <polacek@redhat.com> 2.1-1
- bump to 2.1 version
- bz1014511: restore context only if _scl_root exists

* Thu Aug 08 2013 Marek Polacek <polacek@redhat.com> 2.0-19
- bz978796: propagate LD_LIBRARY_PATH variable to sudo.  Patch by
  Miroslav Franc.

* Mon Jul 15 2013 Marek Polacek <polacek@redhat.com> 2.0-18
- bz984644: require policycoreutils-python for /usr/sbin/semanage

* Fri Jun 21 2013 Marek Polacek <polacek@redhat.com> 2.0-17
- fix preun phase

* Fri Jun 21 2013 Marek Polacek <polacek@redhat.com> 2.0-16
- bz948322: fix the arguments of semanage

* Thu Jun 13 2013 Marek Polacek <polacek@redhat.com> 2.0-15
- bz948322: fix up selinux context

* Mon Apr 29 2013 Marek Polacek <polacek@redhat.com> 2.0-14
- bz957846: toolchain subpackage should require strace

* Wed Apr 24 2013 Frank Ch. Eigler <fche@redhat.com> 2.0-13
- bz920963; bring in sudo wrapper fixes from devtoolset-1.1-12 (bz849452)

* Mon Mar 25 2013 Marek Polacek <polacek@redhat.com> 2.0-12
- require also memstomp and dyninst

* Wed Mar 20 2013 Marek Polacek <polacek@redhat.com> 2.0-11
- devtoolset-2-{ide,perftools,toolchain}: require devtoolset-2-runtime
- fix up devtoolset-2-ide dependencies

* Tue Mar 19 2013 Matt Newsome <mnewsome@redhat.com> 2.0-10
- moved valgrind from devtoolset-2-toolchain to -perftools subpackage

* Thu Mar 14 2013 Marek Polacek <polacek@redhat.com> 2.0-9
- new subpackages: devtoolset-2-{ide,toolchain,perftools}

* Fri Feb 22 2013 Marek Polacek <polacek@redhat.com> 2.0-8
- bz914732: remove dependency on pcp{,-scl-initscripts}

* Fri Jan 25 2013 Marek Polacek <polacek@redhat.com> 2.0-7
- Just bump the version.

* Thu Jan 17 2013 Krzysztof Daniel <kdaniel@redhat.com> 2.0-6
- Make the package noarch again.

* Wed Nov 21 2012 Krzysztof Daniel <kdaniel@redhat.com> 2.0-5
- Add exclusive arch.

* Wed Nov 14 2012 Krzysztof Daniel <kdaniel@redhat.com> 2.0-4
- Fix the %%scl_maven_opts macro.

* Mon Nov 12 2012 Krzysztof Daniel <kdaniel@redhat.com> 2.0-3
- Removed a file specified by mistake in previoius change.

* Fri Nov 9 2012 Krzysztof Daniel <kdaniel@redhat.com> 2.0-2
- Enable Maven support for SCL.

* Wed Oct 31 2012 Marek Polacek <polacek@redhat.com> 2.0-1
- Initial package
